    001/* ===========================================================
    002 * Orson Charts : a 3D chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C)opyright 2013-2022, by David Gilbert.  All rights reserved.
    006 *
    007 * https://github.com/jfree/orson-charts
    008 *
    009 * This program is free software: you can redistribute it and/or modify
    010 * it under the terms of the GNU General Public License as published by
    011 * the Free Software Foundation, either version 3 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This program is distributed in the hope that it will be useful,
    015 * but WITHOUT ANY WARRANTY; without even the implied warranty of
    016 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    017 * GNU General Public License for more details.
    018 *
    019 * You should have received a copy of the GNU General Public License
    020 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
    021 *
    022 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    023 * Other names may be trademarks of their respective owners.]
    024 *
    025 * If you do not wish to be bound by the terms of the GPL, an alternative
    026 * commercial license can be purchased.  For details, please see visit the
    027 * Orson Charts home page:
    028 *
    029 * http://www.object-refinery.com/orsoncharts/index.html
    030 *
    031 */
    032
    033package org.jfree.chart3d.plot;
    034
    035import java.awt.Font;
    036
    037/**
    038 * An object that supplies {@code Font} instances associated with
    039 * keys.  This is used by the {@link PiePlot3D} class to obtain section label
    040 * fonts for each data item(segment) in the chart.  A default implementation
    041 * ({@link StandardFontSource}) is provided.
    042 */
    043public interface FontSource<K> {
    044
    045    /**
    046     * Returns a font based on the supplied key.
    047     *
    048     * @param key  the key ({@code null} not permitted).
    049     *
    050     * @return A font (never {@code null}).
    051     */
    052    Font getFont(K key);
    053
    054    /**
    055     * Sets the font associated with a key.
    056     *
    057     * @param key  the key ({@code null} not permitted).
    058     * @param font  the font ({@code null} not permitted).
    059     */
    060    void setFont(K key, Font font);
    061
    062    /**
    063     * Restyles the source using the specified font.  Refer to the implementing
    064     * class to confirm the precise behaviour (typically all existing font
    065     * settings are cleared and this font is installed as the new default
    066     * section label font).
    067     *
    068     * @param font  the font ({@code null} not permitted).
    069     *
    070     * @since 1.2
    071     */
    072    void style(Font font);
    073
    074}